*  FILE: ADVENT02/ASM

*   <<GET>> SPECIAL PROCS

* GET BOTTLE

GET01 EQU *
 LDA #15
 JSR LOCOBJ
 BNE A@
 LDA #16
 STA NOUNNO
A@ JMP VGET

* GET TANKS

GET02 EQU *
 LDA ROOM
 CMPA #17 DIVE SHOP
 BNE B@
 TST TANKSW
 BNE B@
 LDA #17
 JSR LOCOBJ
 BNE A@
 JMP DMSG50
A@ INC TANKSW
 LDX #MSG56
 JSR DISPLY
B@ JMP VGET

* GET ANCHOR

GET03 EQU *
 LDA #25 ANCHOR IN MUD
 JSR CKOBJ
 LBNE DMSG61
 LDA #97 TIED BALLOON
 JSR CKOBJ
 LBEQ VGET
 CLRB
 JSR CHGOBJ
 JSR CKDRAW
 LDX #MSG66
 JSR DISPLY
 JMP VGET

* GET BALLOON

GET04 EQU *
 LDA #97
 JSR CKOBJ
 BEQ A@
 STA NOUNNO
A@ JMP VGET

*   <<PUT>> SPECIAL PROCS

* PUT BOTTLE

PUT01 EQU *
 LDA #15
 JSR LOCOBJ
 BNE A@
 LDA #16
 STA NOUNNO
A@ JMP VPUT


*   <<GO>> SPECIAL PROC

* GO BOAT

GO01 EQU *
 LDA ROOM
 CMPA #8 DOCK
 BNE A@
 LDA #21
 BRA C@
A@ CMPA #55 ISLAND
 BNE B@
 LDA #33
 BRA C@
B@ CMPA #21
 BLO D@
 CMPA #34
 BHI D@
 BITA #%00000001
 LBNE DMSG13 YOUR ON IT
 DECA
C@ JMP EXITRM
D@ JMP DMSG7 DON'T SEE IT

* GO WATER

GO02 EQU *
 LDA ROOM
 CMPA #8 DOCK
 LBLO DMSG27
 BNE A@
 LDA #22
 BRA C@
A@ CMPA #55 ISLAND
 BNE B@
 LDA #34
 BRA C@
B@ CMPA #21
 BLO D@
 CMPA #34
 BHI D@
 BITA #%00000001
 LBEQ DMSG14 YOU'RE IN IT
 INCA
C@ JMP EXITRM
D@ CMPA #35
 BLO E@
 CMPA #48
 BHI E@
 JMP DMSG14
E@ LDA #126 WATER
 JSR CKOBJ
 LBEQ DMSG7 DON'T SEE IT
 JMP DMSG40 CAN'T DO THAT

* GO DOCK

GO03 EQU *
 LDA ROOM
 CMPA #8
 LBEQ DMSG13
 LDA #125 DOCK
 JSR CKOBJ
 LBEQ DMSG7 DON'T SEE
 LDA #8
 JMP EXITRM

* GO SHORE (ISLAND)

GO04 EQU *
 LDA ROOM
 CMPA #55
 BEQ A@
 CMPA #56
 BEQ A@
 CMPA #57
 BEQ A@
 LDA #124 ISLAND
 JSR CKOBJ
 LBEQ DMSG7 DON'T SEE IT
 LDA #55
 JMP EXITRM
A@ JMP DMSG13 ON IT

* GO FALLS

GO05 EQU *
 LDA ROOM
 CMPA #1
 BEQ A@
 CMPA #9
 LBNE DMSG7
A@ EORA #%00001000
 JMP EXITRM

* GO HOLE

GO06 EQU *
 LDA ROOM
 CMPA #49
 BEQ A@
 CMPA #50
 LBNE DMSG7
A@ EORA #%00000011
 JMP EXITRM

* GO WINDOW

GO07 EQU *
 LDA ROOM
 CMPA #50
 BEQ A@
 CMPA #51
 LBNE DMSG7
A@ LDA #113 BROKEN WINDOW
 JSR CKOBJ
 LBEQ DMSG29 IT'S CLOSED
 LDA ROOM
 EORA #%00000001
 JMP EXITRM

* GO DOOR

GO08 EQU *
 LDA ROOM
 CMPA #50
 BEQ A@
 CMPA #51
 BEQ A@
 LDA #112 DOOR
 JSR CKOBJ
 BNE A@ IT'S CLOSED
 LDA #111 CLOSED DOOR
 JSR CKOBJ
 BNE A@
 LDA #110 OPEN DOOR
 JSR CKOBJ
 LBEQ DMSG7 DON'T SEE
 LDA ROOM
 EORA #1
 JMP EXITRM
A@ JMP DMSG29

* GO STAIRS

GO09 EQU *
 LDA ROOM
 CMPA #6
 LBNE DMSG7
 LDA #11
 JMP EXITRM

* GO CAVE

GO10 EQU *
 LDA ROOM
 CMPA #54
 LBEQ DMSG14
 LDA #101 CAVE
 JSR CKOBJ
 LBEQ DMSG7
 LDA #54 NEW ROOM #
 JMP EXITRM

*  <<LOOK>> SPECIAL PROCS

* LOOK METAL DETECTOR

LOOK01 EQU *
 LDA #8 DETECTOR
 JSR HAVOBJ
 LBNE DMSG16 BUTTON/HANDLE
 JMP DMSG10 DON'T HAVE

* LOOK TANKS

LOOK02 EQU *
 LDA #11 AIR TANKS
 JSR HAVOBJ
 LBEQ DMSG10 DON'T HAVE
 JMP DMSG21 GAUGE ON IT

* LOOK GAUGE

LOOK03 EQU *
 LDA #11 AIR TANKS
 JSR HAVOBJ
 LBEQ DMSG7 DON'T SEE
 LDB AIRCNT
 CLRA
 TFR D,X
 LDY #MSG22A
 JSR ASCLNO
 JSR SUPRES
B@ JMP DMSG22

* LOOK MERMAID

LOOK04 EQU *
 LDA #117 MERMAID
 JSR CKOBJ
 LBEQ DMSG7 DON'T SEE
 JMP DMSG28 SMART REPLY

* LOOK DOOR

LOOK05 EQU *
 LDA ROOM
 CMPA #50
 BEQ A@
 CMPA #51
 BEQ A@
 LDA #110
 JSR CKOBJ
 BNE A@
 LDA #111
 JSR CKOBJ
 BNE A@
 LDA #112
 JSR CKOBJ
 BNE A@
 JMP DMSG7
A@ JMP DMSG29

* LOOK BOTTLE

LOOK06 EQU *
 LDA #15 FULL BOTTLE
 JSR HAVOBJ
 LBNE DMSG37
 LDA #16 EMPTY BOTTLE
 JSR HAVOBJ
 LBNE DMSG38
 JMP DMSG10

* LOOK TABLE

LOOK07 EQU *
 LDA #107 TABLE
 JSR CKOBJ
 LBEQ DMSG7
 LDA #17+INV CREDIT CARD
 JSR CKOBJ
 LBEQ DMSG12
 JSR MAKVIS
 JSR CKDRAW
 JMP DMSG11

* LOOK CREDIT CARD

LOOK08 EQU *
 LDA #17 CREDIT CARD
 JSR HAVOBJ
 LBEQ DMSG10
 LDX #MSG54
 JSR DISPLY
 LDX #MSG55
A@ LDA ,X+
 BEQ C@
 JSR CHROUT
 BSR D@
 LDY #2000
B@ LEAY -1,Y
 BNE B@
 BRA A@
C@ JMP REPLY
D@ PSHS X
 LDA #$30
 LDX #25
 JSR SOUND
 PULS X,PC

* LOOK BOULDER

LOOK09 EQU *
 LDA ROOM
 CMPA #3
 LBEQ DMSG12
 JMP DMSG7

* MOVE BOULDER

MOVE01 EQU *
 LDA #103 BOULDER
 JSR CKOBJ
 BEQ A@
 LDB #102 MOVED BOULDER
 JSR CHGOBJ
 LDA #101 CAVE ENTRANCE
 JSR PUTOBJ
 JSR CKDRAW
 JMP DMSG52
A@ LDA #102
 JSR CKOBJ
 LBEQ DMSG7
 LDB #103
 JSR CHGOBJ
 LDA #101 CAVE ENTRANCE
 CLRB
 JSR CHGOBJ
 JSR CKDRAW
 JMP DMSG53

* LOOK WINDOW

LOOK10 EQU *
 LDA ROOM
 CMPA #50
 LBEQ DMSG12
 JMP VLOOK

* LOOK STEPS

LOOK11 EQU *
 LDA ROOM
 CMPA #6
 LBEQ DMSG12
 JMP DMSG7

* LOOK BALLOON

LOOK12 EQU *
 LDA #97 TIED BALLOON
 JSR CKOBJ
 BNE A@
 LDA NOUNNO BALLOON
 JSR HAVOBJ
 LBEQ DMSG10
A@ JMP DMSG63

* LOOK ROPE & LOOK CORD

LOOK13 EQU *
 LDA #23
 STA NOUNNO
 BRA LOOK12

* LOOK FALLS

LOOK14 EQU *
 LDA ROOM
 CMPA #1
 LBNE VLOOK
 JMP DMSG70

* LOOK ANCHOR

LOOK15 EQU *
 LDA #24 ANCHOR
 JSR LOCOBJ
 BNE A@
 LDA #25 BURIED ANCHOR
 JSR CKOBJ
 BNE A@
 JMP DMSG7
A@ JMP DMSG71

* LOOK CAVE

LOOK16 EQU *
 LDA ROOM
 CMPA #54
 LBEQ DMSG12
 JMP VLOOK

* CLIMB COMMAND PROC

VCLIMB EQU *
 LDA NOUNNO
 CMPA #114 LADDER
 LBNE BADINP
 JSR CKOBJ
 LBEQ DMSG7
 LDA ROOM
 EORA #7
 JMP EXITRM

* CLOSE COMMAND PROC

VCLOSE EQU *
 LDA NOUNNO
 CMPA #112 TRAP DOOR
 BNE B@
 LDB ROOM
 CMPB #50
 BEQ A@
 CMPB #51
 BEQ A@
 JSR CKOBJ
 BNE A@ CLOSED
 LDA #111
 JSR CKOBJ
 BNE A@ CLOSED
 LDA #110 OPEN DOOR
 JSR CKOBJ
 LBEQ DMSG7
 LDB #111 CLOSED DOOR
 JSR CHGOBJ
 JSR CKDRAW
 JMP REPLY
A@ JMP DMSG29
B@ JMP BADINP

* OPEN COMMAND PROC

VOPEN EQU *
 LDA NOUNNO
 CMPA #112 LOCKED DOOR
 BNE A@
 LDB ROOM
 CMPB #50
 LBEQ DMSG35
 CMPB #51
 LBEQ DMSG35
 JSR CKOBJ
 LBNE DMSG30 LOCKED
 LDA #110 OPEN DOOR
 JSR CKOBJ
 LBNE DMSG31 IS OPEN
 LDA #111 CLOSED DOOR
 JSR CKOBJ
 LBEQ DMSG7
 LDB #110 OPEN DOOR
 JSR CHGOBJ
 EXG A,B
 JSR CKDRAW
 JMP REPLY
A@ CMPA #15
 BNE C@
 LDA #16 EMPTY BOTTLE
 JSR HAVOBJ
 LBNE DMSG38
 LDA #15
 JSR HAVOBJ
 LBEQ DMSG10
 LDA #109 SHARK
 JSR CKOBJ
 BEQ B@
 CLRB
 JSR CHGOBJ
 JSR CKDRAW
 LDA #15 BOTTLE
 LDB #16 EMPTY BOTTLE
 JSR REPOBJ
 JMP DMSG39
B@ LDA #15
 LDB #16
 JSR REPOBJ
 JMP DMSG41
C@ CMPA #113 WINDOW
 BNE D@
 LDA ROOM
 CMPA #50
 LBEQ DMSG35
 CMPA #51
 LBEQ DMSG35
 JMP DMSG7
D@ JMP BADINP

* OPEN CLAM

OPEN01 EQU *
 LDA #100 CLAM
 JSR CKOBJ
 LBEQ DMSG7
 LDX #MSG48
 JSR DISPLY
 JSR GETLIN
 JSR SCNKEY
 CLR NOUNNO
 LDX #NOUNTB
 LDY #NOUNNO
 LDU #VERB
 JSR SCNTBL
 LDA NOUNNO
 LBEQ BADINP
 JSR HAVOBJ
 LBEQ DMSG10
 CMPA #10 SHOVEL
 LBNE DMSG36
 LDA #18+INV PEARL
 JSR MAKVIS
 LDA #100 CLAM
 LDB #104 OSYTER
 JSR CHGOBJ
 TFR B,A
 JSR CKDRAW
 LDX #MSG49
 JSR DISPLY
 JMP DMSG11

* TIE COMMAND PROC

VTIE EQU *
 LDA NOUNNO
 CMPA #23 BALLOON
 BEQ A@
 CMPA #95 ROPE
 BEQ A@
 JMP BADINP
A@ LDA #23 BALLOON
 JSR HAVOBJ
 LBEQ DMSG10
 LDX #MSG67
 JSR DISPLY
 JSR GETLIN
 JSR SCNKEY
 CLR NOUNNO
 LDX #NOUNTB
 LDY #NOUNNO
 LDU #VERB
 JSR SCNTBL
 LDA NOUNNO
 LBEQ BADINP
 CMPA #24 ANCHOR
 LBNE DMSG68
 LDA #25 ANCHOR IN MUD
 JSR CKOBJ
 LBEQ DMSG7
 LDA #23
 CLRB
 JSR REPOBJ
 LDA #97 TIED BALLOON
 JSR PUTOBJ
 JSR CKDRAW
 JMP REPLY

* PULL COMMAND PROC

VPULL EQU *
 LDA NOUNNO
 CMPA #96 CORD
 LBNE BADINP
 LDA #23 BALLOON
 JSR LOCOBJ
 BNE A@
 LDA #97 TIED BALLOON
 JSR CKOBJ
 LBEQ DMSG10
 CLRB
 JSR CHGOBJ
 LDA #25 ANCHOR
 JSR CHGOBJ
 LDA #29
 STA ROOM
 LDA #24 ANCHOR
 JSR PUTOBJ
 LDA #97 TIED BALLOON
 JSR PUTOBJ
 LDB #45
 STB ROOM
 JSR CKDRAW
 JMP DMSG64
A@ CLRB
 JSR REPOBJ
 JSR CHGOBJ
 JSR CKDRAW
 LDB ROOM
 PSHS B
 CMPB #57
 BEQ B@
 LDB #57
 BRA C@
B@ LDB #56
C@ STB ROOM
 JSR PUTOBJ DEFLATED BALLOON
 PULS B
 STB ROOM
 JMP DMSG65

* UNLOCK COMMAND PROC

VUNLOC EQU *
 LDA NOUNNO
 CMPA #112 DOOR
 BNE A@
 LDB ROOM
 CMPB #50
 LBEQ DMSG36
 CMPB #51
 LBEQ DMSG36
 LDA #110 OPEN DOOR
 JSR CKOBJ
 LBNE DMSG31 OPEN
 LDA #111 CLOSED DOOR
 JSR CKOBJ
 LBNE DMSG32 UNLOCKED
 LDA #112 LOCKED DOOR
 JSR CKOBJ
 LBEQ DMSG7
 LDA #13 KEY
 JSR HAVOBJ
 LBEQ DMSG33 NEED A KEY
 LDA #112 UNLOCK THE DOOR
 LDB #111
 JSR CHGOBJ
 JMP REPLY
A@ JMP BADINP

* READ COMMAND PROC

VREAD EQU *
 LDA NOUNNO
 CMPA #108 SIGN
 LBNE BADINP
 LDA ROOM
 CMPA #1
 LBEQ DMSG42
 CMPA #54
 LBEQ DMSG44
 CMPA #17
 LBEQ DMSG45
 JMP DMSG7

* READ NOTE

READ01 EQU *
 LDA #19 NOTE
 JSR HAVOBJ
 LBEQ DMSG10
 JMP DMSG47

* READ NEWSPAPER

READ02 EQU *
 LDA NOUNNO NEWSPAPER
 JSR HAVOBJ
 LBEQ DMSG10
 JMP DMSG62

* BREAK COMMAND PROC

VBREAK EQU *
 LDA NOUNNO
 CMPA #113 WINDOW
 BNE A@
 JSR CKOBJ
 LBNE DMSG34
 LDA ROOM
 CMPA #50
 LBNE DMSG7
 LDA #113 BROKEN WINDOW
 JSR PUTOBJ
 JSR CKDRAW
 JMP REPLY
A@ JMP BADINP

* GIVE COMMAND PROC

VGIVE EQU *
 LDA NOUNNO
 LBEQ BADINP
 JSR HAVOBJ
 LBEQ DMSG10 DON'T HAVE
 LDA #117 MERMAID
 JSR CKOBJ
 BEQ A@
 LDA NOUNNO
 CMPA #9 MIRROR
 LBNE DMSG24 DECLINES GIFT
 LDB #13 KEY
 JSR REPOBJ
 LDX #MSG25
 JSR DELAY
 JMP DMSG11 FOUND SOMETHING
A@ LDA #98 PIRATE
 JSR CKOBJ
 LBEQ DMSG23 GIVE IT TO WHO?
 LDA NOUNNO
 CMPA #20 KEG OF RUM
 BNE C@
B@ CLRB
 JSR REPOBJ
 LDA #98 PIRATE
 JSR CHGOBJ
 JSR CKDRAW
 JMP DMSG58
C@ LDX #PNTTAB
D@ TST ,X
 LBEQ DMSG59
 CMPA ,X++
 BNE D@
 TST -1,X
 LBEQ DMSG60
 BRA B@

* FILL COMMAND PROC

VFILL EQU *
 LDA NOUNNO
 CMPA #11 TANKS
 LBNE BADINP
 JSR HAVOBJ
 LBEQ DMSG10
 LDA #115 COMPRESSOR
 JSR CKOBJ
 LBEQ DMSG40 CAN'T DO YET
 LDA #17 CREDIT CARD
 JSR HAVOBJ
 LBEQ DMSG50
 LDA #20
 STA AIRCNT
 LDX #MSG56
 JSR DISPLY
 JMP REPLY

*   **SPECIAL GET ALL CMD**

GETALL EQU *
 LDA ROOM
 CMPA #10
 BNE A@
 LDA #10+INV SHOVEL
 JSR MAKVIS
 BRA B@
A@ CMPA #17
 BNE B@
 TST TANKSW
 BNE B@
 LDA NOUNNO
 CMPA #128 ALL
 BNE B@
 LDA #17 CREDIT CARD
 JSR LOCOBJ
 LBEQ DMSG50
 INC TANKSW
 LDX #MSG56
 JSR DISPLY
B@ JMP VGET

* PUSH BUTTON

PUSH01 EQU *
 LDA #8 DETECTOR
 JSR HAVOBJ
 LBEQ DMSG7
 LDA #9+INV MIRROR
 JSR CKOBJ
 BNE A@
 LDA #14+INV RING
 JSR CKOBJ
 BNE A@
 JMP DMSG17 CLICK
A@ INC DIGSW
 JMP DMSG18 BUZZ

* DIG COMMAND PROC

VDIG EQU *
 LDA NOUNNO
 BEQ C@
 CMPA #122 SAND
 BNE D@
A@ LDA #10 SHOVEL
 JSR HAVOBJ
 LBEQ DMSG19 NO WAY
 LDA #20+INV KEG OF RUM
 JSR CKOBJ
 BEQ F@
E@ JSR MAKVIS
 JSR CKDRAW
 JMP DMSG11
F@ LDA #21+INV RUBY
 JSR CKOBJ
 BNE E@
 TST DIGSW
 BNE B@
 JMP REPLY
B@ CLR DIGSW
 LDA #9+INV MIRROR
 JSR MAKVIS
 JSR CKDRAW
 LDA #14+INV RING
 JSR MAKVIS
 JSR CKDRAW
 JMP DMSG11 FOUND SOMETHING
C@ LDA NOUN
 CMPA #'
 BEQ A@
D@ JMP BADINP

*   **SPECIAL ROOM ENTER**

ENTR10 EQU *
 PSHS A,X
 LDA #10+INV SHOVEL
 JSR CKOBJ
 BEQ A@
 LDX #MSG20 STUMBLE
 JSR DISPLY
A@ PULS A,X,PC
*   **SPECIAL IN ROOM RTNS**

* IN ROOM 1 FIRST TIME

INRM01 EQU *
 PSHS X
 TST FIRST1
 BNE A@
 LDX #MSG72
 JSR DISPLY
 INC FIRST1
A@ PULS X,PC

* 1 ROOM UNDER WATER

UNDER1 EQU *
 PSHS A
 LDA #11 TANKS
 JSR HAVOBJ
 BEQ A@
 TST AIRCNT
 BEQ A@
 DEC AIRCNT
 BNE B@
A@ LDA RMMOVE
 CMPA #3
 BLO B@
UNDERX LDX #MSG26
 JMP DEAD1
B@ PULS A,PC

* 2 OR MORE ROOMS UNDER WATER

UNDER2 EQU *
 PSHS A
 LDA #11 TANKS
 JSR HAVOBJ
 BEQ A@
 TST AIRCNT
 BEQ A@
 DEC AIRCNT
 BNE B@
A@ BRA UNDERX
B@ PULS A,PC

*   **SPECIAL ROOMS EXIT**

* EXIT ROOM 3

EXIT03 EQU *
 PSHS D,X
 CMPB #54 GOING TO ROOM 54?
 BEQ C@ YES
 LDA #101 SEE IF CAVE OPEN
 JSR CKOBJ
 BEQ C@
 LDA RANDOM
 ANDA #$7F
 CMPA #70
 BHI C@
 TST POINTS
 BEQ C@
 BSR D@ SEE IF TREASURE IN CAVE
 BEQ C@
 CLR POINTS
 LDA #54
 STA ROOM
 LDX #PNTTAB
 CLRB
A@ LDA ,X++
 BEQ B@
 JSR CHGOBJ
 BRA A@
B@ TST NOTESW
 BNE C@
 LDA #19 NOTE
 JSR PUTOBJ
 INC NOTESW
C@ PULS D,X,PC
D@ LDA #54
 STA ROOM
 LDX #PNTTAB
E@ TST ,X
 BEQ F@
 LDA ,X++
 JSR CKOBJ
 BNE F@
 BRA E@
F@ RTS

* EXIT BOAT

EXBOAT EQU *
 PSHS D,X,Y
 LDA NOUNNO
 CMPA #4 NORTH/SOUTH/EAST/WEST
 BHI E@
 PSHS D
 LDA #97 BALLOON ON ANCHOR
 JSR CKOBJ
 BEQ F@
 CLRB
 JSR CHGOBJ
 LDA #24 ANCHOR
 JSR CHGOBJ
 INC ROOM
 JSR PUTOBJ
 DEC ROOM
F@ PULS D
 PSHS B
 LDA #RMSIZE
 DECB
 MUL
 ADDD #ROOMTB+6
 TFR D,Y
 LDB ROOM
 LDA #RMSIZE
 DECB
 MUL
 ADDD #ROOMTB+6
 TFR D,X
 LDB #RMOBJ
A@ LDA ,Y+
 CMPA #64
 BHI B@
 CLR -1,Y
B@ DECB
 BNE A@
 PULS B
 STB ROOM
 LDB #RMOBJ
C@ LDA ,X+
 CMPA #64
 BHI D@
 JSR PUTOBJ
D@ DECB
 BNE C@
E@ PULS D,X,Y,PC

* EXIT ROOM 43

EXIT43 EQU *
 PSHS A
 LDA NOUNNO
 CMPA #6 DOWN
 BNE A@
 LDA #109 SHARK
 JSR CKOBJ
 BEQ A@
 LDX #MSG46
 JMP DEAD1
A@ PULS A,PC

* EXIT ROOM 55

EXIT55 EQU *
 PSHS D
 CMPB #56 GOING TO ROOM 56
 BEQ A@
 CMPB #57 GOING TO ROOM 57
 BNE B@
A@ LDA #98 PIRATE
 JSR CKOBJ
 BEQ B@
 LEAS 2,S
 JMP DMSG57
B@ PULS D,PC

**     ANTIMATION ROUTINES

MAKWAV EQU *
 LDX FLIPCT
 LEAX 1,X
 STX FLIPCT
 CMPX #18
 BLO D@
 CLR FLIPCT
 CLR FLIPCT+1
 LDX #GSCRN+(72*32)
 INC OCNCNT
 LDA OCNCNT
 CMPA #6
 BLO A@
 LDD #$2011
 JSR SCRLFT
 LDA OCNCNT
 CMPA #10
 BLO D@
 CLR OCNCNT
 BRA D@
A@ LDD #$2011
 JSR SCRRIT
D@ RTS

* MOVE WATER NEAR BEACH

MOVBCH EQU *
 LDX FLIPCT
 LEAX 1,X
 STX FLIPCT
 CMPX #14
 BLO A@
 CLR FLIPCT
 CLR FLIPCT+1
 LDX #GSCRN+(72*32)
 LDD #$0E02
 JSR SCRRIT
 LDX #GSCRN+(74*32)
 LDD #$0902
 JSR SCRRIT
A@ RTS

* MOVE FALLS ON BEACH SCENE

MOVFAL EQU *
 INC OCNSW
 LDA OCNSW
 CMPA #7
 BLO A@
 CLR OCNSW
 LDX #GSCRN+(40*32)+29
 LDD #$0229
 JSR SCRDN
 LDX #GSCRN+(84*32)
 LDD #$0702
 JSR SCRLFT
 LDX #GSCRN+(83*32)+7
 LDD #$0903
 JSR SCRLFT
 LDX #GSCRN+(82*32)+16
 LDD #$0E04
 JSR SCRLFT
A@ BRA MOVBCH

CAVFAL EQU *
 INC OCNSW
 LDA OCNSW
 CMPA #5
 BLO A@
 CLR OCNSW
 LDX #GSCRN+(49*32)+2
 LDD #$0314
 JSR SCRDN
A@ RTS

* MOVE MERMAID'S TAIL

MOVWED EQU *
 LDD FLIPCT
 ADDD #1
 STD FLIPCT
 CMPD #30
 BLO B@
 LDD #0
 STD FLIPCT
 LDA FLIPSW
 EORA #1
 STA FLIPSW
 BEQ C@
 LDU #MERTL2
 BRA D@
C@ LDU #MERTL1
D@ JSR SHOOVL
B@ RTS

* MOVE WATER FOR FISH TO MOVE

MOVFSH EQU *
 INC OCNCNT
 LDA OCNCNT
 CMPA #4
 BLO ?RTS
 CLR OCNCNT
 LDX #GSCRN+(15*32)
 LDD #$200E
 JSR SCRRIT
 LDX #GSCRN+(29*32)
 LDD #$200F
 JSR SCRLFT
 RTS

* MOVE THE SHARK

MOVSRK EQU *
 INC OCNCNT
 LDA OCNCNT
 CMPA #2
 BLO ?RTS
 CLR OCNCNT
 LDX #GSCRN+(22*32)
 LDD #$2019
 JSR SCRRIT
 RTS

*
* END OF FILE: ADVENT02/ASM
*
