 NAM SEAQUEST
*
* V2.1 - CHANGED NAME TO
*        SEA SEARCH.
*
* V2.2 - CORRECT PROBLEM WHERE
*        "GET ALL" WOULD PICK
*        UP THE ANCHOR STUCK IN
*        THE MUD. (11/10/84)
*
 LIST
 ORG $0400
GSCRN EQU *
MAXWRD EQU 4
MAXOBJ EQU 5
NOVLY  EQU 8
RMOBJ  EQU 19
RMSIZE EQU RMOBJ+6
NORMS  EQU 57 NUMBER OF ROOMS
INV    EQU $80
BLACK  EQU 0
BLUE   EQU 1
RED    EQU 2
WHITE  EQU 3
MAXPNT EQU 100

* ROUTINE INCLUSION PARAMETERS
* SET TO ZERO TO INCLUDE RTN

SRITON EQU 0 SCROLL RIGHT
SLFTON EQU 0 SCROLL LEFT
SUPON  EQU 1 SCROLL UP
SDNON  EQU 0 SCROLL DOWN
SFLPON EQU 0 FLIP COLORS

C.THE  EQU $80
C.YOU  EQU $81
C.ARE  EQU $82
C.SEE  EQU $83
C.CANT EQU $84
C.DONT EQU $85
C.YYOU EQU $86
C.UARE EQU $87
C.INA  EQU $88
C.ONA  EQU $89
C.ISA  EQU $8A
C.IITS EQU $8B
C.TTHE EQU $8C
C.IS   EQU $8D
C.AND  EQU $8E
C.AN   EQU $8F
C.AT   EQU $90

 ORG $0000
ROOM   RMB 1
RANDOM RMB 1
NEWRM  RMB 1
VERBNO RMB 1
NOUNNO RMB 1
VERB   RMB MAXWRD
NOUN   RMB MAXWRD
MSGLNS RMB 1
OCNSW  RMB 1
OCNCNT RMB 1
CLRSW  RMB 1
COLOR1 RMB 1
COLOR2 RMB 1
FLIPSW RMB 1
FLIPCT RMB 2
NOTESW RMB 1
FIRST1 RMB 1
TANKSW RMB 1
DIGSW  RMB 1
AIRCNT RMB 1
RMMOVE RMB 1
SCRTOP RMB 2
POINTS RMB 1
SCORE  RMB 2
OBJCNT RMB 1
OBJECT RMB MAXOBJ
ENDVAR EQU *

*      JUMP VECTORS

CURPOS RMB 3
CLS    RMB 3
CHROUT RMB 3
DISPLY RMB 3
GETLIN RMB 3
BADINP RMB 3
REPLY  RMB 3
SCNKEY RMB 3
PERIOD RMB 3
CHGOBJ RMB 3
CKOBJ  RMB 3
MAKVIS RMB 3
GIVOBJ RMB 3
REPOBJ RMB 3
HAVOBJ RMB 3
GETOBJ RMB 3
PUTOBJ RMB 3
RMVIS  RMB 3
CKDRAW RMB 3
DRAWSC RMB 3
LOCOBJ RMB 3

 REORG
 ORG $0E00

*      VERSION & RELEASE

 FCB 2,2

*      JMP VECTORS STORAGE

SJMPS EQU *
 JMP VEC01 CURPOS
 JMP VEC02 CLS
 JMP VEC03 CHROUT
 JMP VEC04 DISPLY
 JMP VEC05 GETLIN
 JMP VEC06 BADINP
 JMP VEC07 REPLY
 JMP VEC08 SCNKEY
 JMP VEC09 PERIOD
 JMP VEC10 CHGOBJ
 JMP VEC11 CKOBJ
 JMP VEC12 MAKVIS
 JMP VEC13 GIVOBJ
 JMP VEC14 REPOBJ
 JMP VEC15 HAVOBJ
 JMP VEC16 GETOBJ
 JMP VEC17 PUTOBJ
 JMP VEC18 RMVIS
 JMP VEC19 CKDRAW
 JMP VEC20 DRAWSC
 JMP VEC21 LOCOBJ
EJMPS EQU *

 REORG

 RMB 6144 SCREEN MEMORY

START EQU *
 ORCC #$50
 LDS #GSCRN

* BUILD DYNAMIC ROOM SAVE

 CLR ROOM
 LDB #NORMS
 LDX #ROOMTB
 LDY #$8000
A@ PSHS B
 INC ROOM
 LDB #RMOBJ
 LEAX 6,X
B@ LDA ROOM
 STA -1,Y
 LDA ,X+
 BEQ C@
 STA ,--Y
C@ DECB
 BNE B@
 PULS B
 DECB
 BNE A@
 CLR -1,Y

* COLD START INITIALIZATION

 CLR ROOM INIT VARIABLES
 INC ROOM
 LDX #NEWRM
 LDB #ENDVAR-2
 CLRA
E@ STA ,X+
 DECB
 BNE E@
 LDY #SJMPS
 LDB #(EJMPS-SJMPS)/3
D@ LDA ,Y+
 STA ,X+
 LDU ,Y++
 STU ,X++
 DECB
 BNE D@

* WARM START INITIALIZATION

WARM EQU *
 LDX #GSCRN
 STX SCRTOP
 LDX #FIRQ SETUP FIRQ VECTOR
 STX $010D
 STX $010A
 STX $0110
 LDA #$55 SETUP RESET VECTOR
 STA $0071
 LDX #RESET
 STX $0072
 CLR $FF40
 JSR CLS

* GAME UNIQUE INITIALIZATION

 LDX #PNTTAB+1
 LDA #20
 STA ,X++
 STA ,X++
 STA ,X++
 STA ,X++
 STA ,X++

RESET NOP
 LDS #GSCRN
 STS SCRTOP
 LDA #$34
 STA $FF21
 STA $FF23
 STA $FF01
 INCA
 STA $FF03
 LDA $FF02
 ANDC #$EF
 LDA #$FF
 STA $FF22
 STA $FFC0
 STA $FFC3
 STA $FFC5
 LDD #GSCRN
 LSRA
 LDX #$FFC6
 LDB #7
C@ LSRA
 BCS A@
 STB ,X++
 BRA B@
A@ STB 1,X
 LEAX 2,X
B@ DECB
 BNE C@
 CLR NOUNNO
 ORCC #$50
 LDX #GSCRN
 LDY #6144
 LDD #$5555
D@ STD ,X++
 LEAY -2,Y
 BNE D@
E@ JSR [$A000]
 BEQ E@
 JSR CLS
 LDX #BOMBIT
 STX $0072
 LDU #SCRN00
 JSR SHOSCR
 LDX #VERSN
 JSR DISPLY
 LDD #$0100
 STD ROWCOL
 LDX #MDPCRE
 JSR DISPLY
 LDD #$0C00
 STD ROWCOL
 LDX #CREDIT
 JSR DISPLY
G@ LDX FLIPCT
 LEAX 1,X
 STX FLIPCT
 CMPX #500
 BLO N@
 CLR FLIPCT
 CLR FLIPCT+1
 LDA #RED
 STA COLOR1
 LDA #BLACK
 STA COLOR2
 LDX #GSCRN+(49*32)+2
 LDD #$1B20
 JSR FLPCLR
N@ JSR [$A000]
 BEQ G@
 CLR SCORE
 ANDC #$EF
 JMP VLOOK

* BOMB ROUTINE

BOMBIT EQU *
 NOP
 ORCC #$50
 LDX #NEWGAM
 STX $0072
A@ CLR ,X+
 CMPX #$8000
 BLO A@
B@ BRA B@

* RESET FOR NEW GAME

NEWGAM EQU *
 LDB #NORMS
 CLRA
A@ INCA
 JSR CLRRM
 DECB
 BNE A@
 LDX #$8000
B@ LDA ,-X
 BEQ C@
 STA ROOM
 LDA ,-X
 JSR PUTNRM
 BRA B@
C@ CLR ROOM
 INC ROOM
 LDX #NEWRM
 LDB #ENDVAR-NEWRM
D@ CLR ,X+
 DECB
 BNE D@
 JMP WARM

FIRQ EQU *
 JSR CHKANT
 INC RANDOM
 TST $FF00
 TST $FF02
 RTI

 INCL ADVENT00/ASM:1

 INCL ADVENT01/ASM:1

 INCL ADVENT02/ASM:1

 INCL ADVENT03/ASM:1

 INCL ADVENT04/ASM:1

 NLST
 INCL SCRN00/ASM:1
 INCL SCREENS1/ASM:1
 INCL OVERLAY1/ASM:1
 INCL OVERLAY2/ASM:1
 LIST

MDPCRE EQU *
 FCB ' +$80,' +$80,' +$80
 FCC ' MAR','K+$80
 FCC 'DAT','A+$80
 FCC 'PRODUCTS',13,13
 FCB 6[$A0]
 FCC 'presents',0

VERSN EQU *
 FCC 'V2.2',0

CREDIT EQU *
 FCB ' +$80
 FCC 'By',':+$80
 FCC 'Stephe','n+$80,'&+$80
 FCC 'Kath','y+$80
 FCC .O'Dea.,13
 FCB 3[' +$80]
 FCC 'Bo','b+$80,'&+$80
 FCC 'Dolli','e+$80
 FCC 'Withers.'
 FCB 13,13,13,13
 FCB ' +$80,' +$80,' +$80
 FCC 'Copyrigh','t+$80
 FCB $5C+$80 COPYRIGHT
 FCC '1983',13
 FCC . Bob Withers / Stephen O'Dea.
 FCB 13,3[$A0]
 FCC 'Al','l+$80
 FCC 'Right','s+$80
 FCC 'Reserved',0

 INCL ASCLNO/ASM:0

*******************************
*
* GENERAL PURPOSE STRING MOVE
*
*******************************

MOVE EQU *
 ORCC #$50
 PSHS D,X,Y
A@ LDA ,X+
 STA ,Y+
 DECB
 BNE A@
 ANDC #$EF
 PULS D,X,Y,PC

*******************************
*
* DISPLAY COMPRESSED HI-RES
* SCREEN ON VIDEO
*
* INPUT:  U = PNTR TO SCREEN
* OUTPUT: NONE
*
*******************************

SHOSCR EQU *
 JSR CLS
SHOSC2 EQU *
 ORCC #$50
 PSHS D,X,U
 LDX #GSCRN
A@ LDB ,U+
 BEQ C@
 CMPB #$FF
 BEQ E@
B@ LDA ,U+
 STA ,X+
 DECB
 BNE B@
 BRA A@
C@ LDB ,U+
 LDA ,U+
D@ STA ,X+
 DECB
 BNE D@
 BRA A@
 ANDC #$EF
E@ PULS D,X,U,PC

*******************************
*
* DISPLAY GRAPHIC OBJECT ON
* EXISTING SCREEN
* INPUT:  X = PNTR TO OBJECT
*
*******************************

SHOOBJ EQU *
 ORCC #$50
 PSHS D,X,Y,U
 LDB #NOVLY NO OF OVERLAYS
 LDY #SCROBJ
A@ LDA ,X+
 BEQ B@
 DECA
 LSLA
 PSHS B
 TFR A,B
 CLRA
 LDU D,Y
 PULS B
 BSR SHOOVL
B@ DECB
 BNE A@
 LDA ROOM
 DECA
 LDB #RMSIZE
 MUL
 ADDD #ROOMTB+6
 TFR D,X
 LDB #RMOBJ
C@ PSHS B
 LDA ,X+
 BEQ F@
 BMI F@
 LDY #MOVOBJ
D@ TST ,Y
 BEQ F@
 CMPA ,Y
 BEQ G@
E@ LEAY 3,Y
 BRA D@
F@ PULS B
 DECB
 BNE C@
 ANDC #$EF
 PULS D,X,Y,U,PC
G@ LDB 1,Y
 CMPB ROOM
 BNE E@
 LDB 2,Y
 DECB
 LSLB
 PSHS A
 CLRA
 LDY #SCROBJ
 LDU D,Y
 PULS A
 BSR SHOOVL
 BRA F@

SHOOVL PSHS D,X,Y,U
 CLR MODE
D@ LDA ,U+
 DECA
 LDB #32
 MUL
 PSHS D
 LDB ,U+
 CLRA
 DECB
 LSRB
 LSRB
 ADDD ,S++
 ADDD #GSCRN-32
 STD H@
 LDB ,U+
 STB G@
E@ LDB G@
 LDX H@
 LEAX 32,X
 STX H@
F@ BSR OBJBYT
 STA ,X+
 DECB
 BNE F@
 BRA E@
G@ FCB 0 LINE LEN
H@ FDB 0 SCREEN PNTR

OBJBYT EQU *
 PSHS B,X,Y
 LDA MODE
 BEQ E@
 DECA
 BEQ D@
 LDB COUNT
A@ LDA ,U+
B@ DECB
 BNE C@
 CLR MODE
C@ STB COUNT
 PULS B,X,Y,PC
D@ LDB COUNT
 LDA BYTE
 BRA B@
E@ LDA ,U+
 BEQ F@
 CMPA #$FF
 BEQ G@
 TFR A,B
 LDA #2
 STA MODE
 BRA A@
F@ LDB ,U+
 LDA #1
 STA MODE
 LDA ,U+
 STA BYTE
 BRA B@
G@ PULS B,X,Y
 LEAS 2,S
 PULS D,X,Y,U,PC

MODE FCB 0
BYTE FCB 0
COUNT FCB 0

DELAY EQU *
 JSR DISPLY
 LDX #0
 LDB #5
A@ LEAX -1,X
 BNE A@
 DECB
 BNE A@
 RTS

*******************************
*
* CASSETTE SAVE GAME ROUTINE
*
*******************************

VSAVE EQU *
 LDD SCORE
 SUBD #1
 STD SCORE
 LDX #CASMSG
 JSR DISPLY
 JSR GETLIN
 JSR [$A00C] WRITE GAP
 CLR $7C WRITE HEADER BLK
 LDA #15
 STA $7D
 LDX #SAVHDR
 STX $7E
 JSR [$A008] WRITE BLK
 JSR [$A00C] WRITE GAP
 INC $7C
 LDA #CURPOS
 STA $7D
 LDX #ROOM
 STX $7E
 JSR [$A008] WRITE BLK
 LDA #255
 STA $7D
 LDB #(RMSIZE*NORMS)/255+2
 LDX #ROOMTB
 STX $7E
A@ PSHS B
 JSR [$A008] WRITE BLK
 LDX $7E
 LEAX 255,X
 STX $7E
 PULS B
 DECB
 BNE A@
 LDA #$FF
 STA $7C
 CLR $7D
 JSR [$A008] WRITE BLK
 LDA $FF21 TURN OFF CASSETTE
 ANDA #%11110111
 STA $FF21
 JMP REPLY

*******************************
*
* CASSETTE LOAD GAME ROUTINE
*
*******************************

VLOAD EQU *
 LDD SCORE
 SUBD #1
 STD SCORE
 LDX #CASMSG
 JSR DISPLY
 JSR GETLIN
 LDX #$02DD
 STX $7E
 JSR [$A004] READ GAP & BLK
 JSR [$A006]
 TST $81
 BNE D@ IF ERROR
 LDX #$02DD
 LDY #SAVHDR
 LDB #15
A@ LDA ,X+
 CMPA ,Y+
 BNE E@
 DECB
 BNE A@
 LDX #ROOM
 STX $7E
 JSR [$A004] READ GAP & BLK
 JSR [$A006]
 TST $81
 BNE D@ IF ERROR
 LDX #ROOMTB
B@ STX $7E
 JSR [$A006] READ BLK
 BNE D@ IF ERROR
 LDA $7C EOF?
 BMI C@ YES
 LDX $7E
 LEAX 255,X
 BRA B@
C@ LDA $FF21 TURN OFF CASSETTE
 ANDA #%11110111
 STA $FF21
 CLR NOUNNO
 JMP VLOOK
D@ LDX #IOERR
 BRA F@
E@ LDX #BADTAP
F@ JSR DISPLY
 JMP REPLY

CASMSG FCB 13
 FCC 'Read','y+$80
 FCC 'tap','e+$80
 FCB 'i,'n+$80
 FCC 'recorde','r+$80
 FCB C.AND
 FCC 'pres','s+$80
 FCC 'ENTER ',0

BADTAP FCB 13
 FCC 'Invali','d+$80
 FCC 'gam','e+$80
 FCC 'sav','e+$80
 FCC 'tape.',0

IOERR FCB 13
 FCC 'Tap','e+$80
 FCC 'I/','O+$80
 FCC 'error.',0

SAVHDR FCC 'SEAQUEST'
 FCB 2,0,0
 FDB 0,0

* DYNAMIC ROOM TABLE SAVE
* FORMAT: FCB ROOM#,OBJ#
*         FCB 0

 END START
